# coding=utf-8
r"""
This code was generated by
\ / _    _  _|   _  _
 | (_)\/(_)(_|\/| |(/_  v1.0.0
      /       /
"""

from tests import IntegrationTestCase
from tests.holodeck import Request
from twilio.base.exceptions import TwilioException
from twilio.http.response import Response


class ApprovalFetchTestCase(IntegrationTestCase):

    def test_fetch_request(self):
        self.holodeck.mock(Response(500, ''))

        with self.assertRaises(TwilioException):
            self.client.content.v1.contents("HXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX") \
                                  .approval_fetch().fetch()

        self.holodeck.assert_has_request(Request(
            'get',
            'https://content.twilio.com/v1/Content/HXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/ApprovalRequests',
        ))

    def test_get_approval_response(self):
        self.holodeck.mock(Response(
            200,
            '''
            {
                "sid": "HXaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
                "account_sid": "ACaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
                "whatsapp": {
                    "type": "whatsapp",
                    "name": "tree_fiddy",
                    "category": "ACCOUNT_UPDATE",
                    "content_type": "twilio/location",
                    "status": "unsubmitted",
                    "rejection_reason": ""
                },
                "url": "https://content.twilio.com/v1/Content/HXaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa/ApprovalRequests"
            }
            '''
        ))

        actual = self.client.content.v1.contents("HXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX") \
                                       .approval_fetch().fetch()

        self.assertIsNotNone(actual)
